// Qt Headers

#include <qapplication.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qevent.h>
#include <qmenubar.h>

// Local Headers

#include "QALE.h"
#include "example1.h"

class MyGroupBox : public QGroupBox
{
   public:
      MyGroupBox(QWidget *parent);
};

MyGroupBox::MyGroupBox(QWidget *parent)
   : QGroupBox(parent, "groupBox")
{
   (void)new QPushButton(
      "First Button",
      this,
      "button1"
   );

   (void)new QPushButton(
      "Second Button",
      this,
      "button2"
   );

   (void)new QPushButton(
      "Third Button",
      this,
      "button3"
   );
}

Example1::Example1()
   : QMainWindow(0, "example1")
{
   (void)new MyGroupBox(this);

   mQALE = QALE::constructFromFile(this, "example1.qale");
}

Example1::~Example1()
{
   delete mQALE;
}

void Example1::resizeEvent(QResizeEvent *)
{
   mQALE->process();
}

double Example1::getTheWidth() const
{
   return(600.0);
}

double Example1::getTheHeight() const
{
   return(100.0);
}

int main(int argc, char **argv)
{
   QApplication theApplication(argc, argv);

   theApplication.connect(
      &theApplication,
      SIGNAL(lastWindowClosed()),
      &theApplication,
      SLOT(quit())
   );

   Example1 exampleOne;
   exampleOne.show();

   return(theApplication.exec());
}
