// C/C++ headers

#include <stdio.h>
#include <stdlib.h>

// QALE headers

#include "Alignment.h"
#include "cpp_assert.h"

/*****************************************************************************
 * Definition of class: Alignment
 *****************************************************************************/

Alignment::Alignment(Type theType)
   : mType(theType)
{
   // Nothing to do
}

Alignment::~Alignment()
{
   // Nothing to do
}

Alignment::Type Alignment::get() const
{
   return(mType);
}

ostream &operator<<(ostream &out, const Alignment &theObject)
{
   return(
      out << theObject.typeAsString()
   );
}

const char *Alignment::typeAsString() const
{
   char *asString = NULL;

   switch(mType)
   {
      case _LT: asString = "LT"; break;
      case _LC: asString = "LC"; break;
      case _LB: asString = "LB"; break;
      case _CT: asString = "CT"; break;
      case _CC: asString = "CC"; break;
      case _CB: asString = "CB"; break;
      case _RT: asString = "RT"; break;
      case _RC: asString = "RC"; break;
      case _RB: asString = "RB"; break;

      default:
      {
         // Shouldn't ever be here

         CPP_ASSERT(0);
      }
      break;
   }

   return(asString);
}
