// C/C++ headers

#include <string.h>

// Our headers

#include "Component.h"

/*****************************************************************************
 * Definition of class: Component
 *****************************************************************************/

Component::Component(
   int index,
   int defaultWidth,
   int defaultHeight
) :
   mIndex(index),
   mDefaultWidth(defaultWidth),
   mDefaultHeight(defaultHeight)
{
   // Nothing to do
}

Component::~Component()
{
   // Nothing to do
}

double Component::getDefaultWidth() const
{
   return((double)mDefaultWidth);
}

double Component::getDefaultHeight() const
{
   return((double)mDefaultHeight);
}

int Component::getIndex() const
{
   return(mIndex);
}

ostream &operator<<(ostream &out, const Component &theComponent)
{
   using std::endl;

   return(
      out << "left          : " << theComponent.getLeft()         << endl
          << "right         : " << theComponent.getRight()        << endl
          << "top           : " << theComponent.getTop()          << endl
          << "bottom        : " << theComponent.getBottom()       << endl
          << "x             : " << theComponent.getX()            << endl
          << "y             : " << theComponent.getY()            << endl
          << "width         : " << theComponent.getWidth()        << endl
          << "height        : " << theComponent.getHeight()       << endl
          << "default width : " << theComponent.getDefaultWidth() << endl
          << "default height: " << theComponent.getDefaultHeight()
   );
}
