#ifndef _DEFINE_NODE_H_
#   define _DEFINE_NODE_H_

#include "Node.h"

class DefineNode : public Node
{
   public:
      DefineNode(const char *defineName);
      ~DefineNode();

      double evaluate() const;

      ostream &print(ostream &out) const;

      Node *copy() const;

      void accept(Visitor &) const;

      char *getQualifiedName() const;

      char *getDefineName() const;

      void setNode(Node *);

   private:
      DefineNode(const DefineNode &);
      DefineNode &operator=(const DefineNode &);

      char *mQualifiedName;
      char *mDefineName;
      Node *mResolved;
};

#endif
