// C/C++ headers

#include <string.h>
#include <stdio.h>

// QALE headers

#include "Node.h"

/*****************************************************************************
 * Definition of class: Node
 *****************************************************************************/

Node::Node()
{
   // Nothing to do
}

Node::~Node()
{
   // Nothing to do
}

ostream &operator<<(ostream &out, const Node &theNode)
{
   return(theNode.print(out));
}

void Node::split(const char *whole, char **left, char **right)
{
   char *dot = strrchr(whole, '.');

   if(dot == NULL)
   {
      *left  = new char[1];
      *right = new char[strlen(whole) + 1];

      strcpy(*left, "");
      strcpy(*right, whole);
   }
   else
   {
      *left  = new char[dot - whole + 1];
      *right = new char[strlen(dot + 1) + 1];

      sprintf(*left, "%.*s", dot - whole, whole);
      strcpy(*right, dot + 1);
   }
}

char *Node::join(char *left, char *right)
{
   char *buffer = NULL;

   if(left)
   {
      buffer = new char[strlen(left) + strlen(right) + strlen(".") + 1];
      sprintf(buffer, "%s.%s", left, right);
   }
   else
   {
      buffer = new char[strlen(right) + 1];
      strcpy(buffer, right);
   }

   return(buffer);
}
