#ifndef _NODE_H_
#   define _NODE_H_

#include <iostream>
using std::ostream;

class Visitor;

class Node
{
   public:
      Node();

      virtual ~Node();

      virtual double evaluate() const = 0;

      virtual ostream &print(ostream &out) const = 0;

      virtual Node *copy() const = 0;

      virtual void accept(Visitor &) const = 0;

      static void split(const char *whole, char **left, char **right);

      static char *join(char *left, char *right);

   private:
      Node(const Node &);
      Node &operator=(const Node &);
};

ostream &operator<<(ostream &out, const Node &theNode);
#endif
