#ifndef _PROPERTY_NODE_H_
#   define _PROPERTY_NODE_H_

#include "Node.h"

class Component;

class PropertyNode : public Node
{
   public:
      PropertyNode(const char *propertyName);
      ~PropertyNode();

      double evaluate() const;

      ostream &print(ostream &out) const;

      Node *copy() const;

      void accept(Visitor &) const;

      char *getQualifiedName() const;

      char *getPropertyName() const;

      void setComponent(Component *);

   private:
      PropertyNode(const PropertyNode &);
      PropertyNode &operator=(const PropertyNode &);

      char *mQualifiedName;
      char *mPropertyName;
      Component *mComponent;
};

#endif
