#ifndef _QALE_LEXER_H_
#   define _QALE_LEXER_H_

class QALELexer
{
   public:
      static QALELexer *getInstance();
      void begin(const char *text);
      void end();
      int getLineNumber();
      void nextLine();
      int getText(char *dest, int maxSize);
      int getFileOffset();
      int getLineOffset();
      void getCurrentLine(char *line);
      void advance(char *theText);
      enum { MAX_LINE_LENGTH = 255 };

   private:
      QALELexer();
      int mFileOffset;
      int mLineNumber;
      int mLineOffset;
      char *mText;
      int mTextIndex;
      int mTextLength;
};
#endif
